Loading...
1#!/bin/sh
2# SPDX-License-Identifier: GPL-2.0-only
3
4# Copyright (C) 2006 Paul Mackerras, IBM Corporation <paulus@samba.org>
5
6# This script takes a kernel binary and optionally an initrd image
7# and/or a device-tree blob, and creates a bootable zImage for a
8# given platform.
9
10# Options:
11# -o zImage specify output file
12# -p platform specify platform (links in $platform.o)
13# -i initrd specify initrd file
14# -d devtree specify device-tree blob
15# -s tree.dts specify device-tree source file (needs dtc installed)
16# -e esm_blob specify ESM blob for secure images
17# -c cache $kernel.strip.gz (use if present & newer, else make)
18# -C prefix specify command prefix for cross-building tools
19# (strip, objcopy, ld)
20# -D dir specify directory containing data files used by script
21# (default ./arch/powerpc/boot)
22# -W dir specify working directory for temporary files (default .)
23# -z use gzip (legacy)
24# -Z zsuffix compression to use (gz, xz or none)
25
26# Stop execution if any command fails
27set -e
28
29# Allow for verbose output
30if [ "$V" = 1 ]; then
31 set -x
32 map="-Map wrapper.map"
33fi
34
35# defaults
36kernel=
37ofile=zImage
38platform=of
39initrd=
40dtb=
41dts=
42esm_blob=
43cacheit=
44binary=
45compression=.gz
46uboot_comp=gzip
47pie=
48format=
49
50# cross-compilation prefix
51CROSS=
52
53# mkimage wrapper script
54MKIMAGE=$srctree/scripts/mkuboot.sh
55
56# directory for object and other files used by this script
57object=arch/powerpc/boot
58objbin=$object
59dtc=scripts/dtc/dtc
60
61# directory for working files
62tmpdir=.
63
64usage() {
65 echo 'Usage: wrapper [-o output] [-p platform] [-i initrd]' >&2
66 echo ' [-d devtree] [-s tree.dts] [-e esm_blob]' >&2
67 echo ' [-c] [-C cross-prefix] [-D datadir] [-W workingdir]' >&2
68 echo ' [-Z (gz|xz|none)] [--no-compression] [vmlinux]' >&2
69 exit 1
70}
71
72run_cmd() {
73 if [ "$V" = 1 ]; then
74 $* 2>&1
75 else
76 local msg
77
78 set +e
79 msg=$($* 2>&1)
80
81 if [ $? -ne "0" ]; then
82 echo $msg
83 exit 1
84 fi
85 set -e
86 fi
87}
88
89while [ "$#" -gt 0 ]; do
90 case "$1" in
91 -o)
92 shift
93 [ "$#" -gt 0 ] || usage
94 ofile="$1"
95 ;;
96 -p)
97 shift
98 [ "$#" -gt 0 ] || usage
99 platform="$1"
100 ;;
101 -i)
102 shift
103 [ "$#" -gt 0 ] || usage
104 initrd="$1"
105 ;;
106 -d)
107 shift
108 [ "$#" -gt 0 ] || usage
109 dtb="$1"
110 ;;
111 -e)
112 shift
113 [ "$#" -gt 0 ] || usage
114 esm_blob="$1"
115 ;;
116 -s)
117 shift
118 [ "$#" -gt 0 ] || usage
119 dts="$1"
120 ;;
121 -c)
122 cacheit=y
123 ;;
124 -C)
125 shift
126 [ "$#" -gt 0 ] || usage
127 CROSS="$1"
128 ;;
129 -D)
130 shift
131 [ "$#" -gt 0 ] || usage
132 object="$1"
133 objbin="$1"
134 ;;
135 -W)
136 shift
137 [ "$#" -gt 0 ] || usage
138 tmpdir="$1"
139 ;;
140 -z)
141 compression=.gz
142 uboot_comp=gzip
143 ;;
144 -Z)
145 shift
146 [ "$#" -gt 0 ] || usage
147 [ "$1" != "gz" -o "$1" != "xz" -o "$1" != "lzma" -o "$1" != "lzo" -o "$1" != "none" ] || usage
148
149 compression=".$1"
150 uboot_comp=$1
151
152 if [ $compression = ".none" ]; then
153 compression=
154 uboot_comp=none
155 fi
156 if [ $uboot_comp = "gz" ]; then
157 uboot_comp=gzip
158 fi
159 ;;
160 --no-gzip)
161 # a "feature" of the the wrapper script is that it can be used outside
162 # the kernel tree. So keeping this around for backwards compatibility.
163 compression=
164 uboot_comp=none
165 ;;
166 -?)
167 usage
168 ;;
169 *)
170 [ -z "$kernel" ] || usage
171 kernel="$1"
172 ;;
173 esac
174 shift
175done
176
177
178if [ -n "$dts" ]; then
179 if [ ! -r "$dts" -a -r "$object/dts/$dts" ]; then
180 dts="$object/dts/$dts"
181 fi
182 if [ -z "$dtb" ]; then
183 dtb="$platform.dtb"
184 fi
185 $dtc -O dtb -o "$dtb" -b 0 "$dts"
186fi
187
188if [ -z "$kernel" ]; then
189 kernel=vmlinux
190fi
191
192LANG=C elfformat="`${CROSS}objdump -p "$kernel" | grep 'file format' | awk '{print $4}'`"
193case "$elfformat" in
194 elf64-powerpcle) format=elf64lppc ;;
195 elf64-powerpc) format=elf32ppc ;;
196 elf32-powerpc) format=elf32ppc ;;
197esac
198
199ld_version()
200{
201 # Poached from scripts/ld-version.sh, but we don't want to call that because
202 # this script (wrapper) is distributed separately from the kernel source.
203 # Extract linker version number from stdin and turn into single number.
204 awk '{
205 gsub(".*\\)", "");
206 gsub(".*version ", "");
207 gsub("-.*", "");
208 split($1,a, ".");
209 print a[1]*100000000 + a[2]*1000000 + a[3]*10000;
210 exit
211 }'
212}
213
214# Do not include PT_INTERP segment when linking pie. Non-pie linking
215# just ignores this option.
216LD_VERSION=$(${CROSS}ld --version | ld_version)
217LD_NO_DL_MIN_VERSION=$(echo 2.26 | ld_version)
218if [ "$LD_VERSION" -ge "$LD_NO_DL_MIN_VERSION" ] ; then
219 nodl="--no-dynamic-linker"
220fi
221
222platformo=$object/"$platform".o
223lds=$object/zImage.lds
224ext=strip
225objflags=-S
226tmp=$tmpdir/zImage.$$.o
227ksection=.kernel:vmlinux.strip
228isection=.kernel:initrd
229esection=.kernel:esm_blob
230link_address='0x400000'
231make_space=y
232
233
234if [ -n "$esm_blob" -a "$platform" != "pseries" ]; then
235 echo "ESM blob not support on non-pseries platforms" >&2
236 exit 1
237fi
238
239case "$platform" in
240of)
241 platformo="$object/of.o $object/epapr.o"
242 make_space=n
243 ;;
244pseries)
245 platformo="$object/pseries-head.o $object/of.o $object/epapr.o"
246 link_address='0x4000000'
247 if [ "$format" != "elf32ppc" ]; then
248 link_address=
249 pie=-pie
250 fi
251 make_space=n
252 ;;
253maple)
254 platformo="$object/of.o $object/epapr.o"
255 link_address='0x400000'
256 make_space=n
257 ;;
258pmac|chrp)
259 platformo="$object/of.o $object/epapr.o"
260 make_space=n
261 ;;
262coff)
263 platformo="$object/crt0.o $object/of.o $object/epapr.o"
264 lds=$object/zImage.coff.lds
265 link_address='0x500000'
266 make_space=n
267 pie=
268 ;;
269miboot|uboot*)
270 # miboot and U-boot want just the bare bits, not an ELF binary
271 ext=bin
272 objflags="-O binary"
273 tmp="$ofile"
274 ksection=image
275 isection=initrd
276 ;;
277cuboot*)
278 binary=y
279 compression=
280 case "$platform" in
281 *-mpc866ads|*-mpc885ads|*-adder875*|*-ep88xc)
282 platformo=$object/cuboot-8xx.o
283 ;;
284 *5200*|*-motionpro)
285 platformo=$object/cuboot-52xx.o
286 ;;
287 *-pq2fads|*-ep8248e|*-mpc8272*|*-storcenter)
288 platformo=$object/cuboot-pq2.o
289 ;;
290 *-mpc824*)
291 platformo=$object/cuboot-824x.o
292 ;;
293 *-mpc83*|*-asp834x*)
294 platformo=$object/cuboot-83xx.o
295 ;;
296 *-tqm8541|*-mpc8560*|*-tqm8560|*-tqm8555|*-ksi8560*)
297 platformo=$object/cuboot-85xx-cpm2.o
298 ;;
299 *-mpc85*|*-tqm85*|*-sbc85*)
300 platformo=$object/cuboot-85xx.o
301 ;;
302 *-amigaone)
303 link_address='0x800000'
304 ;;
305 esac
306 ;;
307ps3)
308 platformo="$object/ps3-head.o $object/ps3-hvcall.o $object/ps3.o"
309 lds=$object/zImage.ps3.lds
310 compression=
311 ext=bin
312 objflags="-O binary --set-section-flags=.bss=contents,alloc,load,data"
313 ksection=.kernel:vmlinux.bin
314 isection=.kernel:initrd
315 link_address=''
316 make_space=n
317 pie=
318 ;;
319ep88xc|ep405|ep8248e)
320 platformo="$object/fixed-head.o $object/$platform.o"
321 binary=y
322 ;;
323adder875-redboot)
324 platformo="$object/fixed-head.o $object/redboot-8xx.o"
325 binary=y
326 ;;
327simpleboot-*)
328 platformo="$object/fixed-head.o $object/simpleboot.o"
329 binary=y
330 ;;
331asp834x-redboot)
332 platformo="$object/fixed-head.o $object/redboot-83xx.o"
333 binary=y
334 ;;
335xpedite52*)
336 link_address='0x1400000'
337 platformo=$object/cuboot-85xx.o
338 ;;
339gamecube|wii)
340 link_address='0x600000'
341 platformo="$object/$platform-head.o $object/$platform.o"
342 ;;
343treeboot-currituck)
344 link_address='0x1000000'
345 ;;
346treeboot-akebono)
347 link_address='0x1000000'
348 ;;
349treeboot-iss4xx-mpic)
350 platformo="$object/treeboot-iss4xx.o"
351 ;;
352epapr)
353 platformo="$object/pseries-head.o $object/epapr.o $object/epapr-wrapper.o"
354 link_address='0x20000000'
355 pie=-pie
356 ;;
357mvme5100)
358 platformo="$object/fixed-head.o $object/mvme5100.o"
359 binary=y
360 ;;
361mvme7100)
362 platformo="$object/motload-head.o $object/mvme7100.o"
363 link_address='0x4000000'
364 binary=y
365 ;;
366esac
367
368vmz="$tmpdir/`basename \"$kernel\"`.$ext"
369
370# Calculate the vmlinux.strip size
371${CROSS}objcopy $objflags "$kernel" "$vmz.$$"
372strip_size=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" "$vmz.$$")
373
374if [ -z "$cacheit" -o ! -f "$vmz$compression" -o "$vmz$compression" -ot "$kernel" ]; then
375 # recompress the image if we need to
376 case $compression in
377 .xz)
378 xz --check=crc32 -f -6 "$vmz.$$"
379 ;;
380 .gz)
381 gzip -n -f -9 "$vmz.$$"
382 ;;
383 .lzma)
384 xz --format=lzma -f -6 "$vmz.$$"
385 ;;
386 .lzo)
387 lzop -f -9 "$vmz.$$"
388 ;;
389 *)
390 # drop the compression suffix so the stripped vmlinux is used
391 compression=
392 uboot_comp=none
393 ;;
394 esac
395
396 if [ -n "$cacheit" ]; then
397 mv -f "$vmz.$$$compression" "$vmz$compression"
398 else
399 vmz="$vmz.$$"
400 fi
401else
402 rm -f $vmz.$$
403fi
404
405vmz="$vmz$compression"
406
407if [ "$make_space" = "y" ]; then
408 # Round the size to next higher MB limit
409 round_size=$(((strip_size + 0xfffff) & 0xfff00000))
410
411 round_size=0x$(printf "%x" $round_size)
412 link_addr=$(printf "%d" $link_address)
413
414 if [ $link_addr -lt $strip_size ]; then
415 echo "INFO: Uncompressed kernel (size 0x$(printf "%x\n" $strip_size))" \
416 "overlaps the address of the wrapper($link_address)"
417 echo "INFO: Fixing the link_address of wrapper to ($round_size)"
418 link_address=$round_size
419 fi
420fi
421
422# Extract kernel version information, some platforms want to include
423# it in the image header
424version=`${CROSS}strings "$kernel" | grep '^Linux version [-0-9.]' | \
425 cut -d' ' -f3`
426if [ -n "$version" ]; then
427 uboot_version="-n Linux-$version"
428fi
429
430# physical offset of kernel image
431membase=`${CROSS}objdump -p "$kernel" | grep -m 1 LOAD | awk '{print $7}'`
432
433case "$platform" in
434uboot)
435 rm -f "$ofile"
436 ${MKIMAGE} -A ppc -O linux -T kernel -C $uboot_comp -a $membase -e $membase \
437 $uboot_version -d "$vmz" "$ofile"
438 if [ -z "$cacheit" ]; then
439 rm -f "$vmz"
440 fi
441 exit 0
442 ;;
443uboot-obs600)
444 rm -f "$ofile"
445 # obs600 wants a multi image with an initrd, so we need to put a fake
446 # one in even when building a "normal" image.
447 if [ -n "$initrd" ]; then
448 real_rd="$initrd"
449 else
450 real_rd=`mktemp`
451 echo "\0" >>"$real_rd"
452 fi
453 ${MKIMAGE} -A ppc -O linux -T multi -C gzip -a $membase -e $membase \
454 $uboot_version -d "$vmz":"$real_rd":"$dtb" "$ofile"
455 if [ -z "$initrd" ]; then
456 rm -f "$real_rd"
457 fi
458 if [ -z "$cacheit" ]; then
459 rm -f "$vmz"
460 fi
461 exit 0
462 ;;
463esac
464
465addsec() {
466 ${CROSS}objcopy $4 $1 \
467 --add-section=$3="$2" \
468 --set-section-flags=$3=contents,alloc,load,readonly,data
469}
470
471addsec $tmp "$vmz" $ksection $object/empty.o
472if [ -z "$cacheit" ]; then
473 rm -f "$vmz"
474fi
475
476if [ -n "$initrd" ]; then
477 addsec $tmp "$initrd" $isection
478fi
479
480if [ -n "$dtb" ]; then
481 addsec $tmp "$dtb" .kernel:dtb
482 if [ -n "$dts" ]; then
483 rm $dtb
484 fi
485fi
486
487if [ -n "$esm_blob" ]; then
488 addsec $tmp "$esm_blob" $esection
489fi
490
491if [ "$platform" != "miboot" ]; then
492 if [ -n "$link_address" ] ; then
493 text_start="-Ttext $link_address"
494 fi
495#link everything
496 ${CROSS}ld -m $format -T $lds $text_start $pie $nodl -o "$ofile" $map \
497 $platformo $tmp $object/wrapper.a
498 rm $tmp
499fi
500
501# Some platforms need the zImage's entry point and base address
502base=0x`${CROSS}nm "$ofile" | grep ' _start$' | cut -d' ' -f1`
503entry=`${CROSS}objdump -f "$ofile" | grep '^start address ' | cut -d' ' -f3`
504
505if [ -n "$binary" ]; then
506 mv "$ofile" "$ofile".elf
507 ${CROSS}objcopy -O binary "$ofile".elf "$ofile"
508fi
509
510# post-processing needed for some platforms
511case "$platform" in
512pseries|chrp|maple)
513 $objbin/addnote "$ofile"
514 ;;
515coff)
516 ${CROSS}objcopy -O aixcoff-rs6000 --set-start "$entry" "$ofile"
517 $objbin/hack-coff "$ofile"
518 ;;
519cuboot*)
520 gzip -n -f -9 "$ofile"
521 ${MKIMAGE} -A ppc -O linux -T kernel -C gzip -a "$base" -e "$entry" \
522 $uboot_version -d "$ofile".gz "$ofile"
523 ;;
524treeboot*)
525 mv "$ofile" "$ofile.elf"
526 $objbin/mktree "$ofile.elf" "$ofile" "$base" "$entry"
527 if [ -z "$cacheit" ]; then
528 rm -f "$ofile.elf"
529 fi
530 exit 0
531 ;;
532ps3)
533 # The ps3's loader supports loading a gzipped binary image from flash
534 # rom to ram addr zero. The loader then enters the system reset
535 # vector at addr 0x100. A bootwrapper overlay is used to arrange for
536 # a binary image of the kernel to be at addr zero, and yet have a
537 # suitable bootwrapper entry at 0x100. To construct the final rom
538 # image 512 bytes from offset 0x100 is copied to the bootwrapper
539 # place holder at symbol __system_reset_kernel. The 512 bytes of the
540 # bootwrapper entry code at symbol __system_reset_overlay is then
541 # copied to offset 0x100. At runtime the bootwrapper program copies
542 # the data at __system_reset_kernel back to addr 0x100.
543
544 system_reset_overlay=0x`${CROSS}nm "$ofile" \
545 | grep ' __system_reset_overlay$' \
546 | cut -d' ' -f1`
547 system_reset_overlay=`printf "%d" $system_reset_overlay`
548 system_reset_kernel=0x`${CROSS}nm "$ofile" \
549 | grep ' __system_reset_kernel$' \
550 | cut -d' ' -f1`
551 system_reset_kernel=`printf "%d" $system_reset_kernel`
552 overlay_dest="256"
553 overlay_size="512"
554
555 ${CROSS}objcopy -O binary "$ofile" "$ofile.bin"
556
557 run_cmd dd if="$ofile.bin" of="$ofile.bin" conv=notrunc \
558 skip=$overlay_dest seek=$system_reset_kernel \
559 count=$overlay_size bs=1
560
561 run_cmd dd if="$ofile.bin" of="$ofile.bin" conv=notrunc \
562 skip=$system_reset_overlay seek=$overlay_dest \
563 count=$overlay_size bs=1
564
565 odir="$(dirname "$ofile.bin")"
566
567 # The ps3's flash loader has a size limit of 16 MiB for the uncompressed
568 # image. If a compressed image that exceeded this limit is written to
569 # flash the loader will decompress that image until the 16 MiB limit is
570 # reached, then enter the system reset vector of the partially decompressed
571 # image. No warning is issued.
572 rm -f "$odir"/{otheros,otheros-too-big}.bld
573 size=$(${CROSS}nm --no-sort --radix=d "$ofile" | egrep ' _end$' | cut -d' ' -f1)
574 bld="otheros.bld"
575 if [ $size -gt $((0x1000000)) ]; then
576 bld="otheros-too-big.bld"
577 fi
578 gzip -n --force -9 --stdout "$ofile.bin" > "$odir/$bld"
579 ;;
580esac
1#!/bin/sh
2# SPDX-License-Identifier: GPL-2.0-only
3
4# Copyright (C) 2006 Paul Mackerras, IBM Corporation <paulus@samba.org>
5
6# This script takes a kernel binary and optionally an initrd image
7# and/or a device-tree blob, and creates a bootable zImage for a
8# given platform.
9
10# Options:
11# -o zImage specify output file
12# -p platform specify platform (links in $platform.o)
13# -i initrd specify initrd file
14# -d devtree specify device-tree blob
15# -s tree.dts specify device-tree source file (needs dtc installed)
16# -e esm_blob specify ESM blob for secure images
17# -c cache $kernel.strip.gz (use if present & newer, else make)
18# -C prefix specify command prefix for cross-building tools
19# (strip, objcopy, ld)
20# -D dir specify directory containing data files used by script
21# (default ./arch/powerpc/boot)
22# -W dir specify working directory for temporary files (default .)
23# -z use gzip (legacy)
24# -Z zsuffix compression to use (gz, xz or none)
25
26# Stop execution if any command fails
27set -e
28
29# Allow for verbose output
30if [ "$V" = 1 ]; then
31 set -x
32fi
33
34# defaults
35kernel=
36ofile=zImage
37platform=of
38initrd=
39dtb=
40dts=
41esm_blob=
42cacheit=
43binary=
44compression=.gz
45uboot_comp=gzip
46pie=
47format=
48
49# cross-compilation prefix
50CROSS=
51
52# mkimage wrapper script
53MKIMAGE=$srctree/scripts/mkuboot.sh
54
55# directory for object and other files used by this script
56object=arch/powerpc/boot
57objbin=$object
58dtc=scripts/dtc/dtc
59
60# directory for working files
61tmpdir=.
62
63usage() {
64 echo 'Usage: wrapper [-o output] [-p platform] [-i initrd]' >&2
65 echo ' [-d devtree] [-s tree.dts] [-e esm_blob]' >&2
66 echo ' [-c] [-C cross-prefix] [-D datadir] [-W workingdir]' >&2
67 echo ' [-Z (gz|xz|none)] [--no-compression] [vmlinux]' >&2
68 exit 1
69}
70
71run_cmd() {
72 if [ "$V" = 1 ]; then
73 $* 2>&1
74 else
75 local msg
76
77 set +e
78 msg=$($* 2>&1)
79
80 if [ $? -ne "0" ]; then
81 echo $msg
82 exit 1
83 fi
84 set -e
85 fi
86}
87
88while [ "$#" -gt 0 ]; do
89 case "$1" in
90 -o)
91 shift
92 [ "$#" -gt 0 ] || usage
93 ofile="$1"
94 ;;
95 -p)
96 shift
97 [ "$#" -gt 0 ] || usage
98 platform="$1"
99 ;;
100 -i)
101 shift
102 [ "$#" -gt 0 ] || usage
103 initrd="$1"
104 ;;
105 -d)
106 shift
107 [ "$#" -gt 0 ] || usage
108 dtb="$1"
109 ;;
110 -e)
111 shift
112 [ "$#" -gt 0 ] || usage
113 esm_blob="$1"
114 ;;
115 -s)
116 shift
117 [ "$#" -gt 0 ] || usage
118 dts="$1"
119 ;;
120 -c)
121 cacheit=y
122 ;;
123 -C)
124 shift
125 [ "$#" -gt 0 ] || usage
126 CROSS="$1"
127 ;;
128 -D)
129 shift
130 [ "$#" -gt 0 ] || usage
131 object="$1"
132 objbin="$1"
133 ;;
134 -W)
135 shift
136 [ "$#" -gt 0 ] || usage
137 tmpdir="$1"
138 ;;
139 -z)
140 compression=.gz
141 uboot_comp=gzip
142 ;;
143 -Z)
144 shift
145 [ "$#" -gt 0 ] || usage
146 [ "$1" != "gz" -o "$1" != "xz" -o "$1" != "lzma" -o "$1" != "lzo" -o "$1" != "none" ] || usage
147
148 compression=".$1"
149 uboot_comp=$1
150
151 if [ $compression = ".none" ]; then
152 compression=
153 uboot_comp=none
154 fi
155 if [ $uboot_comp = "gz" ]; then
156 uboot_comp=gzip
157 fi
158 ;;
159 --no-gzip)
160 # a "feature" of the the wrapper script is that it can be used outside
161 # the kernel tree. So keeping this around for backwards compatibility.
162 compression=
163 uboot_comp=none
164 ;;
165 -?)
166 usage
167 ;;
168 *)
169 [ -z "$kernel" ] || usage
170 kernel="$1"
171 ;;
172 esac
173 shift
174done
175
176
177if [ -n "$dts" ]; then
178 if [ ! -r "$dts" -a -r "$object/dts/$dts" ]; then
179 dts="$object/dts/$dts"
180 fi
181 if [ -z "$dtb" ]; then
182 dtb="$platform.dtb"
183 fi
184 $dtc -O dtb -o "$dtb" -b 0 "$dts"
185fi
186
187if [ -z "$kernel" ]; then
188 kernel=vmlinux
189fi
190
191LANG=C elfformat="`${CROSS}objdump -p "$kernel" | grep 'file format' | awk '{print $4}'`"
192case "$elfformat" in
193 elf64-powerpcle) format=elf64lppc ;;
194 elf64-powerpc) format=elf32ppc ;;
195 elf32-powerpc) format=elf32ppc ;;
196esac
197
198ld_version()
199{
200 # Poached from scripts/ld-version.sh, but we don't want to call that because
201 # this script (wrapper) is distributed separately from the kernel source.
202 # Extract linker version number from stdin and turn into single number.
203 awk '{
204 gsub(".*\\)", "");
205 gsub(".*version ", "");
206 gsub("-.*", "");
207 split($1,a, ".");
208 print a[1]*100000000 + a[2]*1000000 + a[3]*10000;
209 exit
210 }'
211}
212
213# Do not include PT_INTERP segment when linking pie. Non-pie linking
214# just ignores this option.
215LD_VERSION=$(${CROSS}ld --version | ld_version)
216LD_NO_DL_MIN_VERSION=$(echo 2.26 | ld_version)
217if [ "$LD_VERSION" -ge "$LD_NO_DL_MIN_VERSION" ] ; then
218 nodl="--no-dynamic-linker"
219fi
220
221platformo=$object/"$platform".o
222lds=$object/zImage.lds
223ext=strip
224objflags=-S
225tmp=$tmpdir/zImage.$$.o
226ksection=.kernel:vmlinux.strip
227isection=.kernel:initrd
228esection=.kernel:esm_blob
229link_address='0x400000'
230make_space=y
231
232
233if [ -n "$esm_blob" -a "$platform" != "pseries" ]; then
234 echo "ESM blob not support on non-pseries platforms" >&2
235 exit 1
236fi
237
238case "$platform" in
239of)
240 platformo="$object/of.o $object/epapr.o"
241 make_space=n
242 ;;
243pseries)
244 platformo="$object/pseries-head.o $object/of.o $object/epapr.o"
245 link_address='0x4000000'
246 if [ "$format" != "elf32ppc" ]; then
247 link_address=
248 pie=-pie
249 fi
250 make_space=n
251 ;;
252maple)
253 platformo="$object/of.o $object/epapr.o"
254 link_address='0x400000'
255 make_space=n
256 ;;
257pmac|chrp)
258 platformo="$object/of.o $object/epapr.o"
259 make_space=n
260 ;;
261coff)
262 platformo="$object/crt0.o $object/of.o $object/epapr.o"
263 lds=$object/zImage.coff.lds
264 link_address='0x500000'
265 make_space=n
266 pie=
267 ;;
268miboot|uboot*)
269 # miboot and U-boot want just the bare bits, not an ELF binary
270 ext=bin
271 objflags="-O binary"
272 tmp="$ofile"
273 ksection=image
274 isection=initrd
275 ;;
276cuboot*)
277 binary=y
278 compression=
279 case "$platform" in
280 *-mpc866ads|*-mpc885ads|*-adder875*|*-ep88xc)
281 platformo=$object/cuboot-8xx.o
282 ;;
283 *5200*|*-motionpro)
284 platformo=$object/cuboot-52xx.o
285 ;;
286 *-pq2fads|*-ep8248e|*-mpc8272*|*-storcenter)
287 platformo=$object/cuboot-pq2.o
288 ;;
289 *-mpc824*)
290 platformo=$object/cuboot-824x.o
291 ;;
292 *-mpc83*|*-asp834x*)
293 platformo=$object/cuboot-83xx.o
294 ;;
295 *-tqm8541|*-mpc8560*|*-tqm8560|*-tqm8555|*-ksi8560*)
296 platformo=$object/cuboot-85xx-cpm2.o
297 ;;
298 *-mpc85*|*-tqm85*|*-sbc85*)
299 platformo=$object/cuboot-85xx.o
300 ;;
301 *-amigaone)
302 link_address='0x800000'
303 ;;
304 esac
305 ;;
306ps3)
307 platformo="$object/ps3-head.o $object/ps3-hvcall.o $object/ps3.o"
308 lds=$object/zImage.ps3.lds
309 compression=
310 ext=bin
311 objflags="-O binary --set-section-flags=.bss=contents,alloc,load,data"
312 ksection=.kernel:vmlinux.bin
313 isection=.kernel:initrd
314 link_address=''
315 make_space=n
316 pie=
317 ;;
318ep88xc|ep405|ep8248e)
319 platformo="$object/fixed-head.o $object/$platform.o"
320 binary=y
321 ;;
322adder875-redboot)
323 platformo="$object/fixed-head.o $object/redboot-8xx.o"
324 binary=y
325 ;;
326simpleboot-virtex405-*)
327 platformo="$object/virtex405-head.o $object/simpleboot.o $object/virtex.o"
328 binary=y
329 ;;
330simpleboot-virtex440-*)
331 platformo="$object/fixed-head.o $object/simpleboot.o $object/virtex.o"
332 binary=y
333 ;;
334simpleboot-*)
335 platformo="$object/fixed-head.o $object/simpleboot.o"
336 binary=y
337 ;;
338asp834x-redboot)
339 platformo="$object/fixed-head.o $object/redboot-83xx.o"
340 binary=y
341 ;;
342xpedite52*)
343 link_address='0x1400000'
344 platformo=$object/cuboot-85xx.o
345 ;;
346gamecube|wii)
347 link_address='0x600000'
348 platformo="$object/$platform-head.o $object/$platform.o"
349 ;;
350treeboot-currituck)
351 link_address='0x1000000'
352 ;;
353treeboot-akebono)
354 link_address='0x1000000'
355 ;;
356treeboot-iss4xx-mpic)
357 platformo="$object/treeboot-iss4xx.o"
358 ;;
359epapr)
360 platformo="$object/pseries-head.o $object/epapr.o $object/epapr-wrapper.o"
361 link_address='0x20000000'
362 pie=-pie
363 ;;
364mvme5100)
365 platformo="$object/fixed-head.o $object/mvme5100.o"
366 binary=y
367 ;;
368mvme7100)
369 platformo="$object/motload-head.o $object/mvme7100.o"
370 link_address='0x4000000'
371 binary=y
372 ;;
373esac
374
375vmz="$tmpdir/`basename \"$kernel\"`.$ext"
376
377# Calculate the vmlinux.strip size
378${CROSS}objcopy $objflags "$kernel" "$vmz.$$"
379strip_size=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" "$vmz.$$")
380
381if [ -z "$cacheit" -o ! -f "$vmz$compression" -o "$vmz$compression" -ot "$kernel" ]; then
382 # recompress the image if we need to
383 case $compression in
384 .xz)
385 xz --check=crc32 -f -6 "$vmz.$$"
386 ;;
387 .gz)
388 gzip -n -f -9 "$vmz.$$"
389 ;;
390 .lzma)
391 xz --format=lzma -f -6 "$vmz.$$"
392 ;;
393 .lzo)
394 lzop -f -9 "$vmz.$$"
395 ;;
396 *)
397 # drop the compression suffix so the stripped vmlinux is used
398 compression=
399 uboot_comp=none
400 ;;
401 esac
402
403 if [ -n "$cacheit" ]; then
404 mv -f "$vmz.$$$compression" "$vmz$compression"
405 else
406 vmz="$vmz.$$"
407 fi
408else
409 rm -f $vmz.$$
410fi
411
412vmz="$vmz$compression"
413
414if [ "$make_space" = "y" ]; then
415 # Round the size to next higher MB limit
416 round_size=$(((strip_size + 0xfffff) & 0xfff00000))
417
418 round_size=0x$(printf "%x" $round_size)
419 link_addr=$(printf "%d" $link_address)
420
421 if [ $link_addr -lt $strip_size ]; then
422 echo "INFO: Uncompressed kernel (size 0x$(printf "%x\n" $strip_size))" \
423 "overlaps the address of the wrapper($link_address)"
424 echo "INFO: Fixing the link_address of wrapper to ($round_size)"
425 link_address=$round_size
426 fi
427fi
428
429# Extract kernel version information, some platforms want to include
430# it in the image header
431version=`${CROSS}strings "$kernel" | grep '^Linux version [-0-9.]' | \
432 cut -d' ' -f3`
433if [ -n "$version" ]; then
434 uboot_version="-n Linux-$version"
435fi
436
437# physical offset of kernel image
438membase=`${CROSS}objdump -p "$kernel" | grep -m 1 LOAD | awk '{print $7}'`
439
440case "$platform" in
441uboot)
442 rm -f "$ofile"
443 ${MKIMAGE} -A ppc -O linux -T kernel -C $uboot_comp -a $membase -e $membase \
444 $uboot_version -d "$vmz" "$ofile"
445 if [ -z "$cacheit" ]; then
446 rm -f "$vmz"
447 fi
448 exit 0
449 ;;
450uboot-obs600)
451 rm -f "$ofile"
452 # obs600 wants a multi image with an initrd, so we need to put a fake
453 # one in even when building a "normal" image.
454 if [ -n "$initrd" ]; then
455 real_rd="$initrd"
456 else
457 real_rd=`mktemp`
458 echo "\0" >>"$real_rd"
459 fi
460 ${MKIMAGE} -A ppc -O linux -T multi -C gzip -a $membase -e $membase \
461 $uboot_version -d "$vmz":"$real_rd":"$dtb" "$ofile"
462 if [ -z "$initrd" ]; then
463 rm -f "$real_rd"
464 fi
465 if [ -z "$cacheit" ]; then
466 rm -f "$vmz"
467 fi
468 exit 0
469 ;;
470esac
471
472addsec() {
473 ${CROSS}objcopy $4 $1 \
474 --add-section=$3="$2" \
475 --set-section-flags=$3=contents,alloc,load,readonly,data
476}
477
478addsec $tmp "$vmz" $ksection $object/empty.o
479if [ -z "$cacheit" ]; then
480 rm -f "$vmz"
481fi
482
483if [ -n "$initrd" ]; then
484 addsec $tmp "$initrd" $isection
485fi
486
487if [ -n "$dtb" ]; then
488 addsec $tmp "$dtb" .kernel:dtb
489 if [ -n "$dts" ]; then
490 rm $dtb
491 fi
492fi
493
494if [ -n "$esm_blob" ]; then
495 addsec $tmp "$esm_blob" $esection
496fi
497
498if [ "$platform" != "miboot" ]; then
499 if [ -n "$link_address" ] ; then
500 text_start="-Ttext $link_address"
501 fi
502#link everything
503 ${CROSS}ld -m $format -T $lds $text_start $pie $nodl -o "$ofile" \
504 $platformo $tmp $object/wrapper.a
505 rm $tmp
506fi
507
508# Some platforms need the zImage's entry point and base address
509base=0x`${CROSS}nm "$ofile" | grep ' _start$' | cut -d' ' -f1`
510entry=`${CROSS}objdump -f "$ofile" | grep '^start address ' | cut -d' ' -f3`
511
512if [ -n "$binary" ]; then
513 mv "$ofile" "$ofile".elf
514 ${CROSS}objcopy -O binary "$ofile".elf "$ofile"
515fi
516
517# post-processing needed for some platforms
518case "$platform" in
519pseries|chrp|maple)
520 $objbin/addnote "$ofile"
521 ;;
522coff)
523 ${CROSS}objcopy -O aixcoff-rs6000 --set-start "$entry" "$ofile"
524 $objbin/hack-coff "$ofile"
525 ;;
526cuboot*)
527 gzip -n -f -9 "$ofile"
528 ${MKIMAGE} -A ppc -O linux -T kernel -C gzip -a "$base" -e "$entry" \
529 $uboot_version -d "$ofile".gz "$ofile"
530 ;;
531treeboot*)
532 mv "$ofile" "$ofile.elf"
533 $objbin/mktree "$ofile.elf" "$ofile" "$base" "$entry"
534 if [ -z "$cacheit" ]; then
535 rm -f "$ofile.elf"
536 fi
537 exit 0
538 ;;
539ps3)
540 # The ps3's loader supports loading a gzipped binary image from flash
541 # rom to ram addr zero. The loader then enters the system reset
542 # vector at addr 0x100. A bootwrapper overlay is used to arrange for
543 # a binary image of the kernel to be at addr zero, and yet have a
544 # suitable bootwrapper entry at 0x100. To construct the final rom
545 # image 512 bytes from offset 0x100 is copied to the bootwrapper
546 # place holder at symbol __system_reset_kernel. The 512 bytes of the
547 # bootwrapper entry code at symbol __system_reset_overlay is then
548 # copied to offset 0x100. At runtime the bootwrapper program copies
549 # the data at __system_reset_kernel back to addr 0x100.
550
551 system_reset_overlay=0x`${CROSS}nm "$ofile" \
552 | grep ' __system_reset_overlay$' \
553 | cut -d' ' -f1`
554 system_reset_overlay=`printf "%d" $system_reset_overlay`
555 system_reset_kernel=0x`${CROSS}nm "$ofile" \
556 | grep ' __system_reset_kernel$' \
557 | cut -d' ' -f1`
558 system_reset_kernel=`printf "%d" $system_reset_kernel`
559 overlay_dest="256"
560 overlay_size="512"
561
562 ${CROSS}objcopy -O binary "$ofile" "$ofile.bin"
563
564 run_cmd dd if="$ofile.bin" of="$ofile.bin" conv=notrunc \
565 skip=$overlay_dest seek=$system_reset_kernel \
566 count=$overlay_size bs=1
567
568 run_cmd dd if="$ofile.bin" of="$ofile.bin" conv=notrunc \
569 skip=$system_reset_overlay seek=$overlay_dest \
570 count=$overlay_size bs=1
571
572 odir="$(dirname "$ofile.bin")"
573 rm -f "$odir/otheros.bld"
574 gzip -n --force -9 --stdout "$ofile.bin" > "$odir/otheros.bld"
575 ;;
576esac